      SUBROUTINE CYZY(BR,DR,AR,CY,ZY)
C Determines added mass coefficient CY and vertical co-
C ordinate ZY of its centre of gravity for a Lewis sec-
C tion with (maximum) breadth BR, draught DR and area AR.
      H=BR/(2.*DR)
      AREAC=4*AR/(3.14159*BR*DR)
      ALFA=(H-1.)/(H+1.)
      Q=3+AREAC+ALFA**2*(1.-AREAC)
      ROOT=SQRT(MAX(0.,(9./Q-2.)/Q))
      CY=100.
      DO 10 I=-1,1,2
      P=3/Q+I*ROOT
      D=P-1.
      B=ALFA*P
      CYPREL=((1-B)**2+3.*D**2)/(1-B+D)**2
      IF(CYPREL.LT.CY)THEN
      CY=CYPREL
      ZY=DR * (8./3*(-0.8*D-B*(1+0.8*D-B*P))+D**2*
     & (32./7.-1.6*B))/(3.14159/2.*CY*(1.-B+D)**3)
      ENDIF
10    CONTINUE
      END

