      SUBROUTINE DIPL3D(M,X,Y,Z,XD,YD,ZD,POT,POTX,POTY,POTZ,
     &           POTXX,POTXY,POTXZ,POTYX,POTYY,POTYZ,POTZX,POTZY,POTZZ)
*---------------------------------------------------------------------*
*                                                                     *
*     POTENTIAL OF A 3-D DIPOLE IN X-DIRECTION WITH DERIVATIVES       *
*                                                                     *
*---------------------------------------------------------------------*
      PARAMETER(PI=3.141592654)
      REAL M
      DX=X-XD
      DY=Y-YD
      DZ=Z-ZD
      R2=(DX**2+DY**2+DZ**2)
      R=SQRT(R2)
      R3=R**3
      FAKTOR=-M/(4.*PI*R3)
      POT = FAKTOR*DX
      POTX = -3.*POT*DX/R2+FAKTOR
      POTY = -3.*POT*DY/R2
      POTZ = -3.*POT*DZ/R2
      POTXX = (-5.*POTX*DX-4.*POT)/R2
      POTXY = (-5.*POTX*DY+2.*DY*FAKTOR)/R2
      POTXZ = (-5.*POTX*DZ+2.*DZ*FAKTOR)/R2
      POTYX = POTXY
      POTYY = (-5.*POTY*DY-3.*POT)/R2
      POTYZ = -5.*POTZ*DY/R2
      POTZX = POTXZ
      POTZY = POTYZ
      POTZZ = -POTXX-POTYY
      END

