    ---------------------------------------------------------------------
c      program test
c      common i1,i2
c      external f1,f2
c      do 1 i=1,4
c      i1=0
c      i2=0
c      w1=simps(f1,-6.2,5.,1.,10.**(-i))
c      w2=simps(f2,0.,5.,1.,10.**(-i))
c      write(6,2)w1,i1,w2,i2
c 2    format(2(1f20.10,1i5))
c 1    continue
c      end
c      function f1(x)
c      common i1,i2
c      i1=i1+1
c      f1=exp(-x**2)/sqrt(3.141592654)
c      return
c      end
c      function f2(x)
c      common i1,i2
c      i2=i2+1
c      f2=0.
c      if(x.lt.sqrt(2.))f2=sqrt(0.5)
c      return
c      end

      function simps(f,a,b,dxmax,relgen)
c Integration following Simpson rule
c f = function to be integrated
c a = lower limit of integration
c b = upper limit of integration
c dxmax = max. permissible integration step
c relgen = desired relative accuracy
c simps = integral
      dimension x(21),y(21),z(21)
      x(1)=b
      y(1)=f(b)
      x(2)=(a+b)/2.
      y(2)=f(x(2))
      x(3)=a
      y(3)=f(a)
      lev=3
      ir=0
      simps=(y(1)+4.*y(2)+y(3))/6.*(b-a)
 1    if(lev.lt.19)goto 2
      write(6,3)
 3    format(' Integration numerically impossible')
      stop
 2    if(lev.lt.2)return
      x(lev+1)=x(lev)
      y(lev+1)=y(lev)
      x(lev)=(x(lev+1)+x(lev-1))/2.
      y(lev)=f(x(lev))
      dx=(x(lev-1)-x(lev+1))/2.
      akorr=y(lev+1)+4.*y(lev)+y(lev-1)
      if(ir.eq.0)akorr=(akorr-(2.5*y(lev+1)+4.*y(lev-1)-0.5*y(lev-2)))*
     & dx/3.
      if(ir.eq.0)z(lev)=y(lev+1)
      if(ir.ne.0)akorr=(akorr-(2.5*y(lev-1)+4.*y(lev+1)-0.5*z(lev+1)))*
     & dx/3.
      simps=simps+akorr
      lev=lev+1
      ir=0
      if(dx.ge.dxmax.or.(akorr/(simps+1.e-30))**2.ge.dx/(b-a)*relgen)
     & goto 1
      ir=1
      lev=lev-2
      goto 1
      end

    