      SUBROUTINE SIMQ2(A,N,NR,IM,I,S)
C Gauss algorithms to solve (real) system of linear equations with (optional)
C more than 1 right hand sides. The solver is suitable for full, unsymmitric
C matrices.
C A=matrix of coefficients + negative r.h.s; after execution the solution
C   are stored where previously the r.h.s. were. The coefficient matrix
C   is destroyed. 1st index of A = row (1 to N), 2nd index = column (1 to N+NR)
C NR=number of r.h.s.
C IM=maximal size of 1st index of A in the dimension declaraion of the calling
C    routine
C I=0 usually; not equal 0, if pivot element is smaller than S
C recommended value for S is 1.E-5
      INTEGER I, IM, IMAX, J, K, K1, K2, MMR, N, NNR, NR
      REAL BIGA, S, SAVE
      REAL A(*)
      IMAX=-1000000
      NNR=(N+NR)*IM
      MMR=N*IM
      K1=-IM
      DO 10 I=1,N
         K1=K1+IM+1
         BIGA=A(K1)
         IMAX=K1
         DO 20 J=K1+1,K1+N-I
            IF(ABS(BIGA).LT.ABS(A(J)))THEN
               BIGA=A(J)
               IMAX=J
            ENDIF
20       CONTINUE
         IF(ABS(BIGA).LT.S)RETURN
         A(IMAX)=A(K1)
         DO 30 K=K1+IM,NNR,IM
            IMAX=IMAX+IM
            SAVE=-A(IMAX)/BIGA
            A(IMAX)=A(K)
            A(K)=SAVE
            K2=K1
            DO 40 J=K+1,K+N-I
               K2=K2+1
               A(J)=A(J)+A(K2)*SAVE
40          CONTINUE
30       CONTINUE
10    CONTINUE
      DO 50 I=MMR,NNR-1,IM
         K1=MMR+1
         DO 60 J=N,2,-1
            K1=K1-IM
            K2=I
            SAVE=A(I+J)
            DO 70 K=K1,K1+J-2
               K2=K2+1
               A(K2)=A(K2)+A(K)*SAVE
70          CONTINUE
60       CONTINUE
50    CONTINUE
      I=0
      END

