      SUBROUTINE HUFEIS(LEVEL,GAMMA,BOTTOM,YKANAL,XW,YW,Z1,Z2,X,
     &           PX,PY,PZ,PXX,PXY,PXZ,PYY,PYZ,PXXZ,PXYZ,PXZZ,PYYZ,PYZZ)
C.....horseshoe vortex in x-z plane, from -infinity to x=xw,z=z1
C                     over x=xw,z=z2 to x=-infinity
C     mirror image at z=BOTTOM, but not at z=z0
C     exchanging z1 and z2 is equivalent to -gamma
      INTEGER IKANAL, IBOTTM, IY, IZ, LEVEL, NKANAL
      REAL BOTTOM, GAMMA, X(3), XW, YKANAL, YW,YWI, Z1,Z2, Z1S,Z2S,
     &     PX,PY,PZ,PXX,PXY,PXZ,PYY,PYZ,PXXZ,PXYZ,PXZZ,PYYZ,PYZZ,
     &     QX,QY,QZ,QXX,QXY,QXZ,QYY,QYZ,QXXZ,QXYZ,QXZZ,QYYZ,QYZZ
C.....number of multiplications for canal effect
      IF (YKANAL.EQ.9999) THEN
	 NKANAL = 0
      ELSE
	 NKANAL = 2
      END IF
C.....MSYM = 0 assumed  
      CALL SET0(LEVEL,
     &          PX,PY,PZ,PXX,PXY,PXZ,PYY,PYZ,PXXZ,PXYZ,PXZZ,PYYZ,PYZZ)
C.....mirror image loop for shallow water bottom
      DO 10 IBOTTM = 0, 2, 2
	 IZ = -IBOTTM+1
	 Z1S = IZ*Z1+BOTTOM*IBOTTM
	 Z2S = IZ*Z2+BOTTOM*IBOTTM
C........mirror image loop for port/starb'd symmetry
	 DO 20 IY = 1, -1, -2
C...........loop for canal wall multiplication
	    DO 30 IKANAL = -NKANAL, NKANAL
	       YWI = YW + 2*YKANAL*IKANAL
	       CALL WIRINF(LEVEL,IY*IZ*GAMMA,XW,IY*YWI,Z1S,X,
     &            QX,QY,QZ,QXX,QXY,QXZ,QYY,QYZ,QXXZ,QXYZ,QXZZ,QYYZ,QYZZ)
	       CALL SUM(LEVEL,
     &            PX,PY,PZ,PXX,PXY,PXZ,PYY,PYZ,PXXZ,PXYZ,PXZZ,PYYZ,PYZZ,
     &            QX,QY,QZ,QXX,QXY,QXZ,QYY,QYZ,QXXZ,QXYZ,QXZZ,QYYZ,QYZZ)
	       CALL WIRINF(LEVEL,-IY*IZ*GAMMA,XW,IY*YWI,Z2S,X,
     &            QX,QY,QZ,QXX,QXY,QXZ,QYY,QYZ,QXXZ,QXYZ,QXZZ,QYYZ,QYZZ)
	       CALL SUM(LEVEL,
     &            PX,PY,PZ,PXX,PXY,PXZ,PYY,PYZ,PXXZ,PXYZ,PXZZ,PYYZ,PYZZ,
     &            QX,QY,QZ,QXX,QXY,QXZ,QYY,QYZ,QXXZ,QXYZ,QXZZ,QYYZ,QYZZ)
	       CALL WIRBZ(LEVEL,IY*GAMMA,XW,IY*YWI,Z1S,Z2S,X,
     &            QX,QY,QZ,QXX,QXY,QXZ,QYY,QYZ,QXXZ,QXYZ,QXZZ,QYYZ,QYZZ)
	       CALL SUM(LEVEL,
     &            PX,PY,PZ,PXX,PXY,PXZ,PYY,PYZ,PXXZ,PXYZ,PXZZ,PYYZ,PYZZ,
     &            QX,QY,QZ,QXX,QXY,QXZ,QYY,QYZ,QXXZ,QXYZ,QXZZ,QYYZ,QYZZ)
30          CONTINUE
20       CONTINUE
	 IF (BOTTOM.EQ.9999) GOTO 999
10    CONTINUE
999   CONTINUE
      IF (X(3).EQ.BOTTOM) PZ=0.0
      END

      SUBROUTINE WIRINF(LEVEL,GAMMA,XW,YW,ZW,X,
     & PX,PY,PZ,PXX,PXY,PXZ,PYY,PYZ,PXXZ,PXYZ,PXZZ,PYYZ,PYZZ)
C.....velocity due to vortex piece from x=xw to x=-infinity
      INTEGER LEVEL
      REAL DSQ, DX,DY,DZ, EPS, F, FAKTOR, FAK2, FY, FZ, FYZ, FZZ,
     &     GAMMA, M, PI, T, X(3), XW,YW,ZW, 
     &     PX,PY,PZ,PXX,PXY,PXZ,PYY,PYZ,PXXZ,PXYZ,PXZZ,PYYZ,PYZZ
      PARAMETER (PI=3.1415927,EPS=1.E-6)
      DX = X(1)-XW
      DY = X(2)-YW
      DZ = X(3)-ZW
      DSQ = DY*DY+DZ*DZ
      M = GAMMA/(4*PI)
      IF (DSQ.LE.EPS*DX**2) THEN
	 PX = 0.0
	 PY = 0.0
	 PZ = 0.0
	 IF (LEVEL.GT.1) THEN
	    PXX = 0.0
	    PXY = 0.0
	    PXZ = 0.0
	    PYY = 0.0
	    PYZ = -0.5*M/DX**2
	    IF (LEVEL.GT.2) THEN
	       PXXZ = 0.0
	       PXYZ = 0.0
	       PXZZ = 0.0
	       PYYZ = 0.0
	       PYZZ = 0.0
	    END IF
	 END IF
	 RETURN
      END IF
      T = SQRT(DX**2+DSQ)
      F = M*(1-DX/T)/DSQ
      PX = 0.0
      PY = -F*DZ
      PZ =  F*DY
      IF (LEVEL.GT.1) THEN
	 PXX = 0.0
	 PXY = 0.0
	 PXZ = 0.0
	 FAKTOR = (M*DX/(T**3)-2*F)/DSQ
	 FY = FAKTOR*DY
	 FZ = FAKTOR*DZ
	 PYY = -FY*DZ
	 PYZ = -FZ*DZ-F
	 IF (LEVEL.GT.2) THEN
	    PXXZ = 0.0
	    PXYZ = 0.0
	    PXZZ = 0.0
	    FAK2 = (-3*M*DX*DZ/T**5-4*FZ)/DSQ
	    FYZ = FAK2*DY
	    FZZ = FAK2*DZ+FAKTOR
	    PYYZ = -FYZ*DZ-FY
	    PYZZ = -FZZ*DZ-2*FZ
	 END IF
      END IF
      END 

      SUBROUTINE WIRBZ(LEVEL,GAMMA,XW,YW,Z1,Z2,X,
     &       PX,PY,PZ,PXX,PXY,PXZ,PYY,PYZ,PXXZ,PXYZ,PXZZ,PYYZ,PYZZ)
C.....vortex line section in z-direction
      INTEGER LEVEL
      REAL DSQ, DX,DY, DZ1,DZ2, DZ1SQ,DZ2SQ, EPS, F, FAKTOR, FX,FY,FZ, 
     &     FXZ,FYZ,FZZ, GAMMA, M, PI, T1, T2, X(3), Z1,Z2, XW,YW,
     &     PX,PY,PZ,PXX,PXY,PXZ,PYY,PYZ,PXXZ,PXYZ,PXZZ,PYYZ,PYZZ
      PARAMETER (PI=3.1415927, EPS=1.E-6)
      DX = X(1)-XW
      DY = X(2)-YW
      DZ1 = X(3)-Z1
      DZ2 = X(3)-Z2
      DSQ = DX*DX+DY*DY
      DZ1SQ = DZ1*DZ1
      DZ2SQ = DZ2*DZ2
      M = GAMMA/(4*PI)
      IF (DSQ.LT.EPS*MIN(DZ1SQ,DZ2SQ)) THEN
C........prevent singularity, set everything to zero
	 PX = 0.0
	 PY = 0.0
	 PZ = 0.0
	 IF (LEVEL.GT.1) THEN
	    PXX = 0.0
	    PXY = 0.5*M*(1/DZ1SQ-1/DZ2SQ)
	    PXZ = 0.0
	    PYY = 0.0
	    PYZ = 0.0
	    IF (LEVEL.GT.2) THEN
	       PXXZ = 0.0
	       PXYZ = M*(1/(DZ2SQ*DZ2)-1/(DZ1SQ*DZ1))
	       PXZZ = 0.0
	       PYYZ = 0.0
	       PYZZ = 0.0
	    END IF
	 END IF
	 RETURN
      END IF
      T1 = SQRT(DZ1SQ+DSQ)
      T2 = SQRT(DZ2SQ+DSQ)
      F  = M*(DZ1/T1-DZ2/T2)/DSQ
      PX = -F*DY
      PY =  F*DX
      PZ =  0.0
      IF (LEVEL.GT.1) THEN
	 FAKTOR = (-M*(DZ1/T1**3-DZ2/T2**3)-2*F)/DSQ
	 FX = FAKTOR * DX
	 FY = FAKTOR * DY
	 FZ = M*(1/T1**3-1/T2**3)
	 PXX = -FX * DY
	 PXY = -FY * DY - F
	 PXZ = -FZ * DY
	 PYY = -PXX
	 PYZ =  FZ * DX
	 IF (LEVEL.GT.2) THEN
	    FAKTOR = (-M*((1-3*DZ1SQ/T1**2)/(T1**3)-
     &                    (1-3*DZ2SQ/T2**2)/(T2**3))-2*FZ)/DSQ
	    FXZ = FAKTOR * DX
	    FYZ = FAKTOR * DY
	    FZZ = -3*M*(DZ1/T1**5-DZ2/T2**5)
	    PXXZ = -FXZ * DY
	    PXYZ = -FYZ * DY - FZ
	    PXZZ = -FZZ * DY
	    PYYZ = -PXXZ
	    PYZZ =  FZZ * DX
	 END IF
      END IF
      END

