      function wsp(om,h13,tp,a1,a2,uc,ucdcp)
C wsp = wind sea spectrum for circular frequency om, integral over angle 
C between a1 and a2 relative to main wave direction. Further input parameters:
C h13 significant height, tp peak period. Additional results: uc = wind speed in
C 10 m height, ucdcp= wind speed / wave phase speed at peak freq., linear theory
C All values in m, s and products of these units; angles in rad
      parameter (g=9.81,pi=3.14159)
      dimension xcor(19),fcor(19)
      data xcor/.00,.0089,.0284,.0646,.122,.206,.320,.468,.655,
     & .885,1.,1.046,1.162,1.287,1.490,1.873,2.315,3.390,100./
      data fcor/1.9,1.530,1.399,1.313,1.251,1.201,1.160,1.120,1.069,
     & 1.006,0.98,.991,1.011,1.020,1.020,1.008,0.997,0.989,1.0/
      omp=2*pi/tp
      cp=g/omp
      ucdcp=86.4*(h13*g/cp**2)**2.857
      uc=ucdcp*cp
      do 5 i=2,18
      if(xcor(i).gt.ucdcp)goto 10
5     continue
10    fakt=fcor(i-1)
     & +(fcor(i)-fcor(i-1))*(ucdcp-xcor(i-1))/(xcor(i)-xcor(i-1))
      alpha=.00106*((tp*ucdcp)**2*g/h13)**0.331/fakt**2
      gamma=1.7+max(0.,6*log10(ucdcp))
      sigma=0.08*(1+4/ucdcp**3)
      ggamma=exp(-(om/omp-1)**2/(2*sigma**2))
      if(om/omp.lt.0.95)beta=max(1.24,2.61*(om/omp)**1.3)
      if(om/omp.ge.0.95)beta=max(1.24,2.28*(omp/om)**1.3)
      wsp=alpha*g**2/omp**5*(omp/om)**4*exp(-(omp/om)**4)*gamma**ggamma
     & *0.5*(tanh(beta*a2)-tanh(beta*a1))
C	write(6,*)'alpha,gamma,sigma,ggamma,beta,ucdcp'
C	write(6,*)alpha,gamma,sigma,ggamma,beta,ucdcp
      end

      function wsp1(om,uc,dur,fetch,a1,a2,ucdcp)
C wsp1 = wind sea spectrum for circular frequency om, integral over angle 
C between a1 and a2 relative to main wave direction. Further input parameters:
C uc = wind speed in 10 m height; dur = wind duration; fetch.
C Add. result: ucdcp= wind speed / wave phase speed at peak freq., linear theory
C All values in m, s and products of these units; angles in rad
      parameter (g=9.81,pi=3.14159)
      ucdcp=max(1.,18*(uc**2/g/fetch)**0.3,110*(uc/g/dur)**(3./7.))
      h13=0.21*uc**2/g*ucdcp**(-1.65)
      cp=uc/ucdcp
      omp=g/cp
      tp=2*pi/omp
      write(6,*)'ucdcp,h13,cp,omp,tp',ucdcp,h13,cp,omp,tp
      wsp1= wsp(om,h13,tp,a1,a2,uc,ucdcp)
      write(6,*)'wsp1,ucdcp',wsp1,ucdcp
      end

1     write(6,*)'om,uc,dur,fetch,a1,a2'
      read(5,*)om,uc,dur,fetch,a1,a2
      sp=wsp1(om,uc,dur,fetch,a1,a2,ucdcp)
      write(6,*)sp
      goto 1
      end

